﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AnimalCompApp_v2
{
    class Animal
    {
        //fileds and properties -- automatic properties
        public string Name { get; private set; }
        public int BirthYear { get; private set; }
        public int IdNumber { get; private set; }
        public int BeautyPoints { get; private set; }
        public int BehaviourPoints { get; private set; }
        public static int CurrentYear { get; set; }
        public static int AgeLimit { get; set; }

        //constructor
        public Animal(int idNumber, string name, int birthYear)
        {
            this.IdNumber = idNumber;
            this.Name = name;
            this.BirthYear = birthYear;
        }

        public int Age()
        {
            return CurrentYear - BirthYear;
        }

        public void Scoring(int beautyPoint, int behaviourPoint)
        {
            this.BeautyPoints = beautyPoint;
            this.BehaviourPoints = behaviourPoint;
        }

        public virtual int CalculatePoint()
        {
            //For example if the age limit is 10 years, then the score
            //of a 2 years old animal is:
            //2age*behaviour + (10agelimit-2age)*beauty.)”
            if (Age() < AgeLimit)
            {
                return (Age() * BehaviourPoints + (AgeLimit - Age()) * BeautyPoints);
            }
            return 0;

        }

        public override string ToString()
        {
            return IdNumber + ". " + Name + " named " +
                  this.GetType().Name.ToLower() +
                  " and score is: " + CalculatePoint() + " points";
        }
    }
}
